﻿Imports System.ComponentModel

<DesignerCategory("code")> _
Public Class FramesetTreeView : Inherits TreeView
   Private _TabControl As TabControl
   Public Property TabControl As TabControl
      Get
         Return _TabControl
      End Get
      Set(value As TabControl)
         _TabControl = value
         If _TabControl Is Nothing Then Return
         If Not DesignMode Then Return
         'im Designmode wird der Treeview rekursiv durchlaufen, und den tabs wird die Beschriftung derjenigen Nodes zugewiesen, die keine ChildNodes haben
         Dim i = 0
         Dim tabs = _TabControl.TabPages
         Dim recurse As Action(Of TreeNodeCollection) = Sub(nodes As TreeNodeCollection)
                                                           For Each nd As TreeNode In nodes
                                                              If i >= tabs.Count Then Return
                                                              If nd.Nodes.Count = 0 Then
                                                                 tabs(i).Text = nd.Text
                                                                 i += 1
                                                              Else
                                                                 recurse(nd.Nodes)
                                                              End If
                                                           Next
                                                        End Sub
         recurse(Nodes)
         For i = i To tabs.Count - 1
            tabs(i).Text = tabs(i).Name
         Next
      End Set
   End Property

   Protected Overrides Sub OnAfterSelect(e As System.Windows.Forms.TreeViewEventArgs)
      If e.Node.Nodes.Count = 0 Then
         Dim count = 0
         Dim done = False
         'rekursiv wird der SelectedNode gesucht - dabei werden die Nodes ohne Childnodes gezählt.
         Dim recurse As Action(Of TreeNodeCollection) = Sub(nodes As TreeNodeCollection)
                                                           For Each nd As TreeNode In nodes
                                                              If done Then Return
                                                              If nd.Nodes.Count = 0 Then
                                                                 If nd Is e.Node Then
                                                                    done = True
                                                                    Return
                                                                 End If
                                                                 count += 1
                                                              Else
                                                                 recurse(nd.Nodes)
                                                              End If
                                                           Next
                                                        End Sub
         recurse(Nodes)
         _TabControl.SelectedIndex = count 'count ist der Index des assoziierten tabs
         Me.Focus()
      End If
      MyBase.OnAfterSelect(e)
   End Sub
End Class
